<?php
if (class_exists('TC_Ticket_Template_Elements')) {

    class tc_custom_order_discount_code extends TC_Ticket_Template_Elements {

        var $element_name = 'tc_custom_order_discount_code';
        var $element_title = 'Discount Code';
        var $font_awesome_icon = '<i class="fa fa-percent"></i>';

        function admin_content() {
            echo $this->discount_code_title();
            echo $this->get_font_sizes();
            echo $this->get_font_style();
            echo $this->get_font_colors();
            echo $this->get_cell_alignment();
            echo $this->get_element_margins();
        }

        function discount_code_title() {
            $value = isset($this->template_metas[$this->element_name . '_discount_code_title']) ? $this->template_metas[$this->element_name . '_discount_code_title'] : '';
            ?>
            <label><?php _e('Discount Code Title', 'tc'); ?></label>
            <input type="text" name="<?php echo $this->element_name; ?>_discount_code_title_post_meta" placeholder="<?php echo esc_attr(__('Discount Code', 'tc')); ?>" value="<?php echo esc_attr($value); ?>" />
            <?php
        }

        function ticket_content($ticket_instance_id = false, $ticket_type_id = false) {


            if (isset($ticket_instance_id)) {

                $order_id = wp_get_post_parent_id($ticket_instance_id);

                if (!$ticket_type_id) {
                    $ticket_type_id = get_post_meta($ticket_instance_id, 'ticket_type_id', true);
                }

                $ticket_template_id = get_post_meta($ticket_type_id, apply_filters('tc_ticket_template_field_name', 'ticket_template'), true);

                $discount_code_title = get_post_meta($ticket_template_id, $this->element_name . '_discount_code_title', true);

                if (!empty($discount_code_title)) {
                    $discount_code_title = $discount_code_title . '<br />';
                } else {
                    $discount_code_title = '';
                }

                if (apply_filters('tc_bridge_for_woocommerce_is_active', false) == true) {//WooCommerce Bridge is active so we need to get the Woo discounts used
                    if (get_post_type($ticket_type_id) == 'product_variation') {
                        $ticket_type_id = wp_get_post_parent_id($ticket_type_id);
                    }

                    $ticket_template_id = get_post_meta($ticket_type_id, '_ticket_template', true);

                    $discount_code_title = get_post_meta((int) $ticket_template_id, $this->element_name . '_discount_code_title', true);

                    if (!empty($discount_code_title)) {
                        $discount_code_title = $discount_code_title . '<br />';
                    } else {
                        $discount_code_title = '';
                    }

                    $order = new WC_Order($order_id);

                    if ($order->get_used_coupons()) {
                        $coupons_list = implode(', ', $order->get_used_coupons());
                        $discount_code_to_show = $discount_code_title . '' . $coupons_list;
                    } else {
                        $discount_code_to_show = '';
                    }
                } else {

                    $discounts = new TC_Discounts();
                    $discount_total = $discounts->get_discount_total_by_order($order_id);

                    if ($discount_total > 0) {
                        $discount_code = get_post_meta($order_id, 'tc_discount_code', true);
                        $discount_code_to_show = $discount_code_title . '' . $discount_code;
                    } else {
                        $discount_code_to_show = '';
                    }
                }
            } else {
                $discount_code_to_show = $discount_code_title . 'EXAMPLE';
            }

            return $discount_code_to_show;
        }

    }

    tc_register_template_element('tc_custom_order_discount_code', __('Discount Code', 'tc'));
}

